"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleFoundEntity = void 0;
const AP = __importStar(require("@activity-kit/types"));
const utilities_1 = require("@activity-kit/utilities");
const type_utilities_1 = require("@activity-kit/type-utilities");
async function handleFoundEntity(entity, render) {
    if (this.returnHtml) {
        const expandedEntity = await this.core.expandEntity(entity);
        if (type_utilities_1.guard.isTypeOf(expandedEntity, AP.ActorTypes)) {
            const outbox = await this.core.expandCollection(expandedEntity.outbox);
            if (type_utilities_1.guard.isApType(outbox, AP.CollectionTypes.ORDERED_COLLECTION)) {
                expandedEntity.outbox = outbox;
            }
        }
        return {
            statusCode: 200,
            body: await render({
                entity: expandedEntity,
            }),
        };
    }
    else {
        const json = (0, utilities_1.convertEntityToJson)((0, utilities_1.cleanProps)((0, utilities_1.applyContext)(entity)));
        return {
            statusCode: 200,
            body: JSON.stringify(json),
        };
    }
}
exports.handleFoundEntity = handleFoundEntity;
//# sourceMappingURL=handleFoundEntity.js.map