export declare const ExtendedObjectTypes: {
    readonly ARTICLE: "Article";
    readonly AUDIO: "Audio";
    readonly DOCUMENT: "Document";
    readonly EVENT: "Event";
    readonly IMAGE: "Image";
    readonly NOTE: "Note";
    readonly PAGE: "Page";
    readonly PLACE: "Place";
    readonly PROFILE: "Profile";
    readonly RELATIONSHIP: "Relationship";
    readonly TOMBSTONE: "Tombstone";
    readonly VIDEO: "Video";
    readonly HASHTAG: "Hashtag";
};
export declare const LinkTypes: {
    readonly LINK: "Link";
    readonly MENTION: "Mention";
};
export declare const ActorTypes: {
    readonly APPLICATION: "Application";
    readonly GROUP: "Group";
    readonly ORGANIZATION: "Organization";
    readonly PERSON: "Person";
    readonly SERVICE: "Service";
};
export declare const TransitiveActivityTypes: {
    readonly ACCEPT: "Accept";
    readonly ADD: "Add";
    readonly ANNOUNCE: "Announce";
    readonly BLOCK: "Block";
    readonly IGNORE: "Ignore";
    readonly CREATE: "Create";
    readonly DELETE: "Delete";
    readonly DISLIKE: "Dislike";
    readonly FLAG: "Flag";
    readonly FOLLOW: "Follow";
    readonly INVITE: "Invite";
    readonly JOIN: "Join";
    readonly LEAVE: "Leave";
    readonly LIKE: "Like";
    readonly LISTEN: "Listen";
    readonly MOVE: "Move";
    readonly OFFER: "Offer";
    readonly READ: "Read";
    readonly REJECT: "Reject";
    readonly REMOVE: "Remove";
    readonly TENTATIVE_ACCEPT: "TentativeAccept";
    readonly TENTATIVE_REJECT: "TentativeReject";
    readonly UNDO: "Undo";
    readonly UPDATE: "Update";
    readonly VIEW: "View";
};
export declare const IntransitiveActivityTypes: {
    readonly ARRIVE: "Arrive";
    readonly TRAVEL: "Travel";
    readonly QUESTION: "Question";
};
export declare const ActivityTypes: {
    readonly ARRIVE: "Arrive";
    readonly TRAVEL: "Travel";
    readonly QUESTION: "Question";
    readonly ACCEPT: "Accept";
    readonly ADD: "Add";
    readonly ANNOUNCE: "Announce";
    readonly BLOCK: "Block";
    readonly IGNORE: "Ignore";
    readonly CREATE: "Create";
    readonly DELETE: "Delete";
    readonly DISLIKE: "Dislike";
    readonly FLAG: "Flag";
    readonly FOLLOW: "Follow";
    readonly INVITE: "Invite";
    readonly JOIN: "Join";
    readonly LEAVE: "Leave";
    readonly LIKE: "Like";
    readonly LISTEN: "Listen";
    readonly MOVE: "Move";
    readonly OFFER: "Offer";
    readonly READ: "Read";
    readonly REJECT: "Reject";
    readonly REMOVE: "Remove";
    readonly TENTATIVE_ACCEPT: "TentativeAccept";
    readonly TENTATIVE_REJECT: "TentativeReject";
    readonly UNDO: "Undo";
    readonly UPDATE: "Update";
    readonly VIEW: "View";
};
export declare const CollectionTypes: {
    readonly COLLECTION: "Collection";
    readonly ORDERED_COLLECTION: "OrderedCollection";
};
export declare const CollectionPageTypes: {
    readonly COLLECTION_PAGE: "CollectionPage";
    readonly ORDERED_COLLECTION_PAGE: "OrderedCollectionPage";
};
export declare const CoreObjectTypes: {
    readonly COLLECTION_PAGE: "CollectionPage";
    readonly ORDERED_COLLECTION_PAGE: "OrderedCollectionPage";
    readonly COLLECTION: "Collection";
    readonly ORDERED_COLLECTION: "OrderedCollection";
    readonly ARRIVE: "Arrive";
    readonly TRAVEL: "Travel";
    readonly QUESTION: "Question";
    readonly ACCEPT: "Accept";
    readonly ADD: "Add";
    readonly ANNOUNCE: "Announce";
    readonly BLOCK: "Block";
    readonly IGNORE: "Ignore";
    readonly CREATE: "Create";
    readonly DELETE: "Delete";
    readonly DISLIKE: "Dislike";
    readonly FLAG: "Flag";
    readonly FOLLOW: "Follow";
    readonly INVITE: "Invite";
    readonly JOIN: "Join";
    readonly LEAVE: "Leave";
    readonly LIKE: "Like";
    readonly LISTEN: "Listen";
    readonly MOVE: "Move";
    readonly OFFER: "Offer";
    readonly READ: "Read";
    readonly REJECT: "Reject";
    readonly REMOVE: "Remove";
    readonly TENTATIVE_ACCEPT: "TentativeAccept";
    readonly TENTATIVE_REJECT: "TentativeReject";
    readonly UNDO: "Undo";
    readonly UPDATE: "Update";
    readonly VIEW: "View";
    readonly APPLICATION: "Application";
    readonly GROUP: "Group";
    readonly ORGANIZATION: "Organization";
    readonly PERSON: "Person";
    readonly SERVICE: "Service";
    readonly ARTICLE: "Article";
    readonly AUDIO: "Audio";
    readonly DOCUMENT: "Document";
    readonly EVENT: "Event";
    readonly IMAGE: "Image";
    readonly NOTE: "Note";
    readonly PAGE: "Page";
    readonly PLACE: "Place";
    readonly PROFILE: "Profile";
    readonly RELATIONSHIP: "Relationship";
    readonly TOMBSTONE: "Tombstone";
    readonly VIDEO: "Video";
    readonly HASHTAG: "Hashtag";
};
export declare const AllTypes: {
    readonly LINK: "Link";
    readonly MENTION: "Mention";
    readonly COLLECTION_PAGE: "CollectionPage";
    readonly ORDERED_COLLECTION_PAGE: "OrderedCollectionPage";
    readonly COLLECTION: "Collection";
    readonly ORDERED_COLLECTION: "OrderedCollection";
    readonly ARRIVE: "Arrive";
    readonly TRAVEL: "Travel";
    readonly QUESTION: "Question";
    readonly ACCEPT: "Accept";
    readonly ADD: "Add";
    readonly ANNOUNCE: "Announce";
    readonly BLOCK: "Block";
    readonly IGNORE: "Ignore";
    readonly CREATE: "Create";
    readonly DELETE: "Delete";
    readonly DISLIKE: "Dislike";
    readonly FLAG: "Flag";
    readonly FOLLOW: "Follow";
    readonly INVITE: "Invite";
    readonly JOIN: "Join";
    readonly LEAVE: "Leave";
    readonly LIKE: "Like";
    readonly LISTEN: "Listen";
    readonly MOVE: "Move";
    readonly OFFER: "Offer";
    readonly READ: "Read";
    readonly REJECT: "Reject";
    readonly REMOVE: "Remove";
    readonly TENTATIVE_ACCEPT: "TentativeAccept";
    readonly TENTATIVE_REJECT: "TentativeReject";
    readonly UNDO: "Undo";
    readonly UPDATE: "Update";
    readonly VIEW: "View";
    readonly APPLICATION: "Application";
    readonly GROUP: "Group";
    readonly ORGANIZATION: "Organization";
    readonly PERSON: "Person";
    readonly SERVICE: "Service";
    readonly ARTICLE: "Article";
    readonly AUDIO: "Audio";
    readonly DOCUMENT: "Document";
    readonly EVENT: "Event";
    readonly IMAGE: "Image";
    readonly NOTE: "Note";
    readonly PAGE: "Page";
    readonly PLACE: "Place";
    readonly PROFILE: "Profile";
    readonly RELATIONSHIP: "Relationship";
    readonly TOMBSTONE: "Tombstone";
    readonly VIDEO: "Video";
    readonly HASHTAG: "Hashtag";
};
export type AnyType = (typeof AllTypes)[keyof typeof AllTypes];
export type TypeOrArrayWithType<T extends AnyType> = T | [T, ...Array<AnyType>];
